// picformatExtractor.cpp : Implementation of CpicformatExtractor
#include "stdafx.h"
#include "thumbplug_picApp.h"
#include "Thumbpicformat_i.h"
#include "picformatExtractor.h"
#include "readpic.h"
#include <shlobj.h>

#if 0
    void GATReportEvent2 (const char* msg, const char* filename)
    {
        HANDLE hndl = RegisterEventSource(NULL, "thumbplug_pic");
        if (hndl != NULL)
        {
            const char* strTbl[2];
            
            strTbl[0] = msg;
            strTbl[1] = filename;
            ReportEvent (hndl, EVENTLOG_ERROR_TYPE, 0, 0, NULL, 2, 0, &strTbl[0], NULL);
            DeregisterEventSource (hndl);
        }
    }
    #define GATReportError(msg,filename)    GATReportEvent2(msg,filename)
    #define GATReportStatus(msg,filename)    GATReportEvent2(msg,filename)
#else
    #define GATReportError(msg,filename)
    #define GATReportStatus(msg,filename)
#endif

#define SAVE_TARGAS 0
#if SAVE_TARGAS
typedef unsigned char uint8;
typedef struct TGAHeader
{
	uint8	ID;				// Byte 0
	uint8	ctype;			// Byte 1
	uint8	itype;			// Byte 2
	uint8	mincolorl;		// Byte 3
	uint8	mincolorh;		// Byte 4
	uint8	colorsl;		// Byte 5
	uint8	colorsh;		// Byte 6
	uint8	colorsize;		// Byte 7
	uint8	originxl;		// Byte 8
	uint8	originxh;		// Byte 9
	uint8	originyl;		// Byte 10
	uint8	originyh;		// Byte 11
	uint8	widthl;			// Byte 12
	uint8	widthh;			// Byte 13
	uint8	heightl;		// Byte 14
	uint8	heighth;		// Byte 15
	uint8	bpp;			// Byte 16
	uint8	idesc;			// Byte 17
} TGAHeader;

bool saveTGA24Bit (const char* filename, BITMAPINFO* qt_pBitmapInfo, char* qt_pPixels)
{
	static TGAHeader tgaHeader =
	{
	0,	//	uint8	ID;				// Byte 0
	0,	//	uint8	ctype;			// Byte 1
	2,	//	uint8	itype;			// Byte 2
	0,	//	uint8	mincolorl;		// Byte 3
	0,	//	uint8	mincolorh;		// Byte 4
	0,	//	uint8	colorsl;		// Byte 5
	0,	//	uint8	colorsh;		// Byte 6
	0,	//	uint8	colorsize;		// Byte 7
	0,	//	uint8	originxl;		// Byte 8
	0,	//	uint8	originxh;		// Byte 9
	0,	//	uint8	originyl;		// Byte 10
	0,	//	uint8	originyh;		// Byte 11
	0,	//	uint8	widthl;			// Byte 12
	0,	//	uint8	widthh;			// Byte 13
	0,	//	uint8	heightl;		// Byte 14
	0,	//	uint8	heighth;		// Byte 15
	24,	//	uint8	bpp;			// Byte 16
	0,	//	uint8	idesc;			// Byte 17
	};
    DWORD numWritten;
	HANDLE	fh;
	uint8 *BRGBuffer;

	fh = CreateFile (filename, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL); 
	if (fh == INVALID_HANDLE_VALUE)
	{
        GATReportStatus ("can't open file for writing:", filename);
		return false;
    }
    
	BRGBuffer = (uint8 *)HeapAlloc (GetProcessHeap(), 0 , qt_pBitmapInfo->bmiHeader.biWidth * qt_pBitmapInfo->bmiHeader.biHeight * 3);
	if (!BRGBuffer)
	{
        GATReportStatus ("out of memory saving tga:", filename);
		return false;
	}

	tgaHeader.widthl = (uint8)(qt_pBitmapInfo->bmiHeader.biWidth % 256);
	tgaHeader.widthh = (uint8)(qt_pBitmapInfo->bmiHeader.biWidth / 256);

	tgaHeader.heightl = (uint8)(qt_pBitmapInfo->bmiHeader.biHeight % 256);
	tgaHeader.heighth = (uint8)(qt_pBitmapInfo->bmiHeader.biHeight / 256);

    WriteFile (fh, &tgaHeader, sizeof (tgaHeader), &numWritten, NULL);

	{
		uint8	*s = (uint8*)qt_pPixels;
		uint8	*d = BRGBuffer;
		long	 count = qt_pBitmapInfo->bmiHeader.biWidth * qt_pBitmapInfo->bmiHeader.biHeight;

		while (count)
		{
			*d++ = *s++;
			*d++ = *s++;
			*d++ = *s++;
			//*d++ = s->alpha;

			count--;
		}
	}

    // if we read them upsidedown then don't flip them for saving
    #if READ_UPSIDEDOWN
    #else
    //	flipBuffer (BRGBuffer, bop->width * 3, bop->height);
    #endif
    WriteFile (fh, BRGBuffer, qt_pBitmapInfo->bmiHeader.biWidth * qt_pBitmapInfo->bmiHeader.biHeight * 3, &numWritten, NULL);
	HeapFree (GetProcessHeap(), 0 , BRGBuffer);
    CloseHandle (fh);

	return TRUE;

}

void saveTGA(const char* filename, const char* extra, BITMAPINFO* qt_pBitmapInfo, char* qt_pPixels)
{
    char name[MAX_PATH];
    const char *s = filename + strlen (filename);
    
    while (s > filename && s[-1] != '\\') --s;
    if (*s == '\\') ++s;
    
    strcpy (name, "c:\\temp\\tga_test\\");
    strcat (name, s);
    strcat (name, extra);
    strcat (name, ".tga");
    
    GATReportStatus ("saving make thumbnail:", name);
    saveTGA24Bit (name, qt_pBitmapInfo, qt_pPixels);
}
#endif

/////////////////////////////////////////////////////////////////////////////
// CpicformatExtractor

HRESULT CpicformatExtractor::GetLocation(LPWSTR pszPathBuffer,
		DWORD cchMax, DWORD *pdwPriority,
		const SIZE *prgSize, DWORD dwRecClrDepth,
		DWORD *pdwFlags)
{
	//*pdwFlags &= ~IEIFLAG_ASYNC;
	// if (*pdwFlags & IEIFLAG_ASYNC)  MessageBox(0,"async",0,0);
	// if (*pdwFlags & IEIFLAG_ASPECT)  MessageBox(0,"aspect",0,0);
	//if (*pdwFlags & IEIFLAG_SCREEN)  MessageBox(0,"screen",0,0);

    GATReportStatus ("asked to get location:", m_szFile);
	//*pdwFlags &= IEIFLAG_REFRESH;
	m_bmSize = *prgSize;
	if (*pdwFlags & IEIFLAG_ASYNC)	return E_PENDING; 
	return NOERROR;
}

HRESULT CpicformatExtractor::Load(LPCOLESTR wszFile, DWORD dwMode)
{
	USES_CONVERSION;
	_tcscpy(m_szFile, OLE2T((WCHAR*)wszFile)); 
    GATReportStatus ("asked to load file:", m_szFile);
	//MessageBox(0,m_szFile,0,0);
	return S_OK;	
};

	// IExtractImage::Extract
HRESULT CpicformatExtractor::Extract(HBITMAP* phBmpThumbnail)
{ 
    HBITMAP hThumb;
    SIZE bmDocSize;
    HDC hMEMDC;
	HGDIOBJ hOLDOBJ;
	char*			qt_pPixels;
    BITMAPINFO*		qt_pBitmapInfo = NULL;
    HBITMAP			qt_hBITMAP = NULL;

    GATReportStatus ("asked to make thumbnail:", m_szFile);
    qt_pBitmapInfo =  texReadPIC (m_szFile, &qt_hBITMAP, &qt_pPixels);
    if (!qt_pBitmapInfo)
    {
        GATReportError ("could not read file", m_szFile);
        goto error;
    }
    GATReportStatus ("made thumbnail:", m_szFile);

	bmDocSize.cx = qt_pBitmapInfo->bmiHeader.biWidth;
	bmDocSize.cy = qt_pBitmapInfo->bmiHeader.biHeight;

    // Create memory DC, create a color bitmap, and draw on it
	hMEMDC = ::CreateCompatibleDC(NULL);
	hThumb = ::CreateBitmap(m_bmSize.cx,m_bmSize.cy, ::GetDeviceCaps(hMEMDC, PLANES), ::GetDeviceCaps(hMEMDC, BITSPIXEL), NULL); 
    
	hOLDOBJ = ::SelectObject(hMEMDC, hThumb);
	::PatBlt(hMEMDC, 0, 0, m_bmSize.cx, m_bmSize.cy, WHITENESS);

    GATReportStatus ("cleared rect:", m_szFile);
    
    int newWidth;
    int newHeight;
    
    newWidth  = qt_pBitmapInfo->bmiHeader.biWidth;
    newHeight = qt_pBitmapInfo->bmiHeader.biHeight;

    // scale based on which is higher			
    if (newWidth > m_bmSize.cx)
    {
        newHeight = (newHeight*m_bmSize.cx)/newWidth;
        newWidth  = m_bmSize.cx;
    }
    if (newHeight > m_bmSize.cy)
    {
        newWidth  = (newWidth*m_bmSize.cy)/newHeight;
        newHeight = m_bmSize.cy;
    }

	::SetStretchBltMode (hMEMDC, HALFTONE);
	::SetBrushOrgEx (hMEMDC, 0, 0, NULL);
	::StretchDIBits (hMEMDC, 0, 0, newWidth, newHeight, 0, 0, qt_pBitmapInfo->bmiHeader.biWidth, qt_pBitmapInfo->bmiHeader.biHeight, qt_pPixels, qt_pBitmapInfo, DIB_RGB_COLORS, SRCCOPY);

    GATReportStatus ("stretch bits:", m_szFile);
    
   	// TODO: You may choose to change the mapping here
	::SetMapMode(hMEMDC, MM_ISOTROPIC);
	::SetViewportExtEx(hMEMDC, m_bmSize.cx,-m_bmSize.cy, NULL);
	::SetWindowExtEx(hMEMDC, bmDocSize.cx,bmDocSize.cy, NULL);
	if (hOLDOBJ) ::SelectObject(hMEMDC, hOLDOBJ); 

    #if SAVE_TARGAS
    saveTGA (m_szFile, "_end", qt_pBitmapInfo, qt_pPixels);
    #endif
    
	if (qt_hBITMAP)     ::DeleteObject (qt_hBITMAP);
    if (qt_pBitmapInfo) HeapFree (GetProcessHeap(), 0 , qt_pBitmapInfo);
    
	//::LoadBitmap(_Module.GetModuleInstance(),MAKEINTRESOURCE(IDB_BITMAP2)); 
	*phBmpThumbnail = hThumb;
	return NOERROR; 

error:
    if (qt_hBITMAP) DeleteObject (qt_hBITMAP);
    if (qt_pBitmapInfo) HeapFree (GetProcessHeap(), 0 , qt_pBitmapInfo);
    
    *phBmpThumbnail = NULL;

    return E_FAIL;
}

HRESULT CpicformatExtractor::GetDateStamp(FILETIME *pDateStamp)
{
    GATReportStatus ("asked to read date:", m_szFile);
	FILETIME ftCreationTime,ftLastAccessTime,ftLastWriteTime;
	// open the file and get last write time
	HANDLE hFile = CreateFile(m_szFile,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,0,NULL);
	if(!hFile)
    {
        GATReportError ("could not get date for file", m_szFile);
        return E_FAIL;
    }
	GetFileTime(hFile,&ftCreationTime,&ftLastAccessTime,&ftLastWriteTime);
	CloseHandle(hFile);
	*pDateStamp = ftLastWriteTime;
	return NOERROR; 
}

